
	-- INITIAL VARIABLES --

-- Lets add all the watched players in this table --

charactersTable = {}

-- Create initial frame that retrieves Savedvariables and Creates the main addon frame --

init_frame = CreateFrame("Frame", "Initial_Frame", UIParent)
init_frame:RegisterEvent("ADDON_LOADED")
init_frame:SetScript("OnEvent", function() createAndLoad() end)

-- Creates main frame, positions and add events --


function createAndLoad()
	print("TRRWL LOADED!")

	init_frame:UnregisterEvent("ADDON_LOADED")
	
	if positionXaxis == nil and positionYaxis == nil then
		print("Initialising position.")
		positionXaxis = 0
		positionYaxis = 0
	end
	
	if sizeXaxis == nil and sizeYaxis == nil then
		sizeXaxis = 200
		sizeYaxis = 300
	end

	Eyeon = CreateFrame("Frame", "EyeOn", UIParent, "BasicFrameTemplate")
	EyeOn:SetSize(sizeXaxis, sizeYaxis)
	EyeOn:SetPoint("CENTER", UIParent, "CENTER", positionXaxis, positionYaxis)
	EyeOn:RegisterEvent("UNIT_POWER_UPDATE")
	EyeOn:SetScript("OnEvent", function() updateResource() end)
	EyeOn:EnableMouse(true)

	EyeOn.title = EyeOn:CreateFontString(nil, "OVERLAY")
	EyeOn.title:SetFontObject("GameFontNormalSmall")
	EyeOn.title:SetPoint("LEFT", EyeOn.TitleBg, "LEFT", 5, 0)
	EyeOn.title:SetText("EyeOn")
	
	EyeOn.avarageMana = EyeOn:CreateFontString(nil, "OVERLAY")
	EyeOn.avarageMana:SetFontObject("GameFontNormalLarge")
	EyeOn.avarageMana:SetPoint("CENTER", EyeOn, "TOP", 0, -40)
	EyeOn.avarageMana:SetText("Avarage : 0 %")

	EyeOn.text = EyeOn:CreateFontString(nil, "OVERLAY")
	EyeOn.text:SetFontObject("GameFontNormalSmall")
	EyeOn.text:SetPoint("CENTER", EyeOn, "TOP", 0, -150)
	EyeOn.text:SetText("/eon add <player>")
end


commandTable = {["show"] = function()
					EyeOn:Show()
				end,
				["add"] = function(text)
					addPlayer(text)
				end,
				["remove"] = function(text)
					removePlayer(text)
				end,
				["position"] = function(text)
					changePosition(text)
				end,
				["size"] = function(text)
					changeSize(text)
				end
				}
				
SLASH_EyeOn1 = "/eon"
SlashCmdList["EyeOn"] = function(text)
	commandExecute(text, commandTable)
end
	
-- Executes the slash commands. --
-- Argument1 - Player entered text. --
	
function commandExecute(text)
	local command, parameters = strsplit(" ", text, 2)
	local entry = commandTable[command:lower()]
	local which = type(entry)
	if which == "function" then
		entry(parameters)
	elseif which == "table" then
		commandExecute(parameters, entry)
	end
end

function addPlayer(text)
	local players = {strsplit(" ", text)}
	for key, value in pairs(players) do
		playerToAdd = value:gsub("^%l", string.upper)
		print(playerToAdd ..  " added to the Watch List")
		table.insert(charactersTable, playerToAdd)
	end
	updateResource(charactersTable)
end

function removePlayer(text)
	local players = {strsplit(" ", text)}
	for key, value in pairs(players) do
		playerToRemove = value:gsub("^%l", string.upper)
		for key, character in pairs(charactersTable) do
			if character == playerToRemove then
				table.remove(charactersTable, key)
				updateResource(charactersTable)
			end
		end
	end
end

function changePosition(position)
	local positionx, positiony = strsplit(" ", position, 2)
	EyeOn:SetPoint("CENTER", UIParent, "CENTER", positionx, positiony)
	positionXaxis = positionx
	positionYaxis = positiony
end

function changeSize(size)
	local x, y = strsplit(" ", size, 2)
	EyeOn:SetSize(x, y)
	sizeXaxis = x
	sizeYaxis = y
end

function printText(charactersTable)
	for key, character in pairs(charactersTable) do
		printManaValue(character)
	end
end

function updateResource()
	
	updateText = ""
	maxMana = 0
	currentMana = 0
	
	for key, character in pairs(charactersTable) do
		maxPower = UnitPowerMax(character, Mana, false)
		currentPower = UnitPower(character, Mana, false)
		manaPercent = math.floor(currentPower * 100 / maxPower)
		maxMana = maxMana + maxPower
		currentMana = currentMana + currentPower
		if manaPercent > 74 then
			updateText = updateText .. "|cFF00FF00"
		elseif manaPercent > 25 then
			updateText = updateText .. "|cFFFFFF00"
		else
			updateText = updateText ..	"|cFFFF0000"
		end
		updateText = updateText .. character .. " - " .. manaPercent .. " %" .. string.char(10) .. string.char(10)
	end
	
	avarageManaPercent = math.floor(currentMana * 100 / maxMana)
	avarageManaText = "Avarage : 0 %"
	
	if avarageManaPercent >= 50 then
		avarageManaText = "|cFF00FF00Avarage : " .. avarageManaPercent .. " %"
	elseif avarageManaPercent >= 15 then
		avarageManaText = "|cFFFFFF00Avarage : " .. avarageManaPercent .. " %"
	else
		avarageManaText = "|cFFFF0000Avarage : " .. avarageManaPercent .. " %"
	end
	
	EyeOn.avarageMana:SetText(avarageManaText)
	EyeOn.text:SetText(updateText)
end

function printManaValue(player)
	
	maxPower = UnitPowerMax(player, Mana, false)
	currentPower = UnitPower(player, Mana, false)
	manaPercent = math.floor(currentPower * 100 / maxPower)
	if manaPercent >= 50 then
		print("|cFF00FF00" .. player .. " - " .. manaPercent .. " %")
	elseif manaPercent >= 20 then
		print("|cFFFFFF00" .. player .. " - " .. manaPercent .. " %")
	else
		print("|cFFFF0000" .. player .. " - " .. manaPercent .. " %")
	end
end
	



